namespace Eastbanc.VSIP.TextTemplating.VSHost
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Globalization;
    using System.Text;

    internal class InclusionListConverter : TypeConverter
    {
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            if (sourceType == typeof(string))
            {
                return true;
            }
            return base.CanConvertFrom(context, sourceType);
        }

        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
            if (destinationType == typeof(string))
            {
                return true;
            }
            return base.CanConvertTo(context, destinationType);
        }

        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            if (culture == null)
            {
                throw new ArgumentNullException("culture");
            }
            if (context == null)
            {
                throw new ArgumentNullException("context");
            }
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            if (value.GetType() != typeof(string))
            {
                throw new InvalidOperationException(Resources.OptionsPageUIFail);
            }
            InclusionList list1 = new InclusionList();
            string text1 = (string) value;
            string[] textArray1 = text1.Split(new string[] { ";" }, StringSplitOptions.RemoveEmptyEntries);
            string[] textArray3 = textArray1;
            for (int num1 = 0; num1 < textArray3.Length; num1++)
            {
                string text2 = textArray3[num1];
                Inclusion inclusion1 = new Inclusion();
                inclusion1.FullName = text2;
                list1.Add(inclusion1);
            }
            return list1;
        }

        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
        {
            if (destinationType != typeof(string))
            {
                throw new InvalidOperationException(Resources.OptionsPageUIFail);
            }
            InclusionList list1 = value as InclusionList;
            if (list1 == null)
            {
                throw new InvalidOperationException(Resources.OptionsPageUIFail);
            }
            StringBuilder builder1 = new StringBuilder();
            bool flag1 = true;
            List<Inclusion>.Enumerator enumerator1 = list1.GetEnumerator();
            try
            {
                while (enumerator1.MoveNext())
                {
                    Inclusion inclusion1 = enumerator1.Current;
                    if (!flag1)
                    {
                        builder1.Append(";");
                    }
                    builder1.Append(inclusion1.FullName);
                    flag1 = false;
                }
            }
            finally
            {
                enumerator1.Dispose();
            }
            return builder1.ToString();
        }

        public override bool GetCreateInstanceSupported(ITypeDescriptorContext context)
        {
            return true;
        }


        private const string separator = ";";
    }
}

