namespace Eastbanc.VSIP.TextTemplating.VSHost
{
    using Microsoft.VisualStudio.Modeling;
    using Microsoft.VisualStudio.TextTemplating;
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.Globalization;
    using System.Reflection;

    public abstract class ModelingTextTransformation : TextTransformation
    {
        protected ModelingTextTransformation()
        {
            this.domainModels = new List<Type>();
        }

        protected void AddDomainModel(Type modelType)
        {
            if (modelType == null)
            {
                throw new ArgumentNullException("modelType");
            }
            if (!this.domainModels.Contains(modelType))
            {
                this.domainModels.Add(modelType);
            }
        }

        protected override void Dispose(bool disposing)
        {
            try
            {
                if (disposing && (this.store != null))
                {
                    this.store.Dispose();
                    this.store = null;
                }
                this.store = null;
            }
            finally
            {
                base.Dispose(disposing);
            }
        }

        protected override void Initialize()
        {
            base.Initialize();

            this.store = new Microsoft.VisualStudio.Modeling.Store();
            Type[] typeArray1 = this.domainModels.ToArray();
            this.Store.LoadMetaModels(typeArray1);
            Type[] typeArray2 = typeArray1;

            for (int num1 = 0; num1 < typeArray2.Length; num1++)
            {
                Type type1 = typeArray2[num1];
                if (type1 != null)
                {
                    try
                    {
                        object[] objArray1 = new object[] { this.Store };
                        type1.Assembly.CreateInstance(type1.FullName, false, BindingFlags.Public | BindingFlags.Instance, null, objArray1, null, null);
                    }
                    catch (Exception exception1)
                    {
                        base.Error(string.Format(CultureInfo.InvariantCulture, Resources.ModelingDomainModelFail, new object[] { type1.FullName }));
                        base.Error(exception1.ToString());
                    }
                }
            }
            
        }


        protected Microsoft.VisualStudio.Modeling.Store Store
        {
            [DebuggerStepThrough]
            get
            {
                return this.store;
            }
        }


        private List<Type> domainModels;
        private Microsoft.VisualStudio.Modeling.Store store;

        public override string TransformText()
        {
            throw new Exception("The method or operation is not implemented.");
        }
    }
}

