using System;
using Microsoft.VisualStudio.Shell.Interop;
using Microsoft.VisualStudio.Shell;
using Microsoft.VisualStudio.Package;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using Microsoft.VisualStudio;

namespace Eastbanc.VSIP.Sdm.VSProject
{

    [ComVisible(true), Guid("A7CB0D83-DDDF-41e1-A67E-05FE712A581C")]
    public class ConfigurationPropertyPage : BuildPropertyPage
    {
        #region fields
        private String _targetRegistryRoot;
        private bool _registerSdmOutput;
        #endregion

        public ConfigurationPropertyPage():base()
        {
            
        }

        protected override int ApplyChanges()
        {
            this.SetConfigProperty(SdmProjectFileConstants.TargetRegistryRoot, _targetRegistryRoot);
            this.SetConfigProperty(SdmProjectFileConstants.RegisterSdmOutput, _registerSdmOutput.ToString());

            return base.ApplyChanges();
        }

        protected override void BindProperties()
        {
            base.BindProperties();


            _registerSdmOutput = Utilities.ConvertFromProjectProperty(this.GetConfigProperty(SdmProjectFileConstants.RegisterSdmOutput), false);
            _targetRegistryRoot = this.GetConfigProperty(SdmProjectFileConstants.TargetRegistryRoot);

            IsDirty = false;
        }

        #region Properties
        [SRCategoryAttribute("Build")]
        [LocDisplayName(SR.TargetRegistryRoot)]
        [SRDescriptionAttribute(SR.TargetRegistryRootDescription)]
        public String TargetRegistryRoot
        {
            get { return _targetRegistryRoot; }
            set { _targetRegistryRoot = value; IsDirty = true; }
        }

        [SRCategoryAttribute("Build")]
        [LocDisplayName(SR.RegisterSdmOutput)]
        [SRDescriptionAttribute(SR.RegisterSdmOutputDescription)]
        public bool RegisterSdmOutput
        {
            get { return _registerSdmOutput; }
            set { _registerSdmOutput = value; IsDirty = true; }
        }
        #endregion
    }
}
