using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Globalization;
using System.Text;
using System.Threading;
using System.Reflection;
using Microsoft.VisualStudio.Shell.Interop;
using Microsoft.VisualStudio.OLE.Interop;
using Microsoft.VisualStudio.Shell;
using OleConstants = Microsoft.VisualStudio.OLE.Interop.Constants;
using VsCommands = Microsoft.VisualStudio.VSConstants.VSStd97CmdID;
using VsCommands2K = Microsoft.VisualStudio.VSConstants.VSStd2KCmdID;
//using MSBuild = Microsoft.Build.BuildEngine;
using Microsoft.VisualStudio.Package;

namespace Eastbanc.VSIP.Sdm.VSProject
{
    [CLSCompliant(false), ComVisible(true)]
    public class SdmDocumentReferenceContainerNode : ReferenceContainerNode
    {
        #region ctor
        public SdmDocumentReferenceContainerNode(ProjectNode root)
            : base(root)
		{
			this.VirtualNodeName = ReferencesNodeVirtualName;
			this.ExcludeNodeFromScc = true;
		}
		#endregion

        #region Properties
        private static string[] supportedReferenceTypes = new string[] {
			ProjectFileConstants.ProjectReference,
			ProjectFileConstants.Reference,
			ProjectFileConstants.COMReference,
            SdmProjectFileConstants.SdmDocumentReference

		};
        protected override string[] SupportedReferenceTypes
        {
            get { return supportedReferenceTypes; }
        }
        #endregion

        protected override ReferenceNode CreateCustomProjectReferenceNode(ProjectElement element)
        {
            return new SdmDocumentReferenceNode(this.ProjectMgr, element);
        }

        protected override ReferenceNode CreateCustomProjectReferenceNode(VSCOMPONENTSELECTORDATA selectorData)
        {
            if(String.Compare(Path.GetExtension(selectorData.bstrFile), ".sdmDocument", true) == 0)
                return new SdmDocumentReferenceNode(this.ProjectMgr, selectorData.bstrFile);

            return null;
        }
        
    }
}
