using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SystemDefinitionModel.Tools;

namespace Eastbanc.VSIP.Sdm.VSProject
{
    internal class Utilities
    {
        static public WarningLevel ConvertFromProjectProperty(String propertyValue, WarningLevel defaultLevel)
        {
            if (String.IsNullOrEmpty(propertyValue))
                return defaultLevel;

            try
            {
                return (WarningLevel)Enum.Parse(typeof(WarningLevel), propertyValue);
            }
            catch (InvalidCastException)
            {
                return defaultLevel;
            }
        }

        static public String ConvertToProjectProperty(WarningLevel warningLevel)
        {
            return ((int)warningLevel).ToString();
        }

        static public int ConvertFromProjectProperty(String propertyValue, int defaultValue)
        {
            if (String.IsNullOrEmpty(propertyValue))
                return defaultValue;

            try
            {
                return int.Parse(propertyValue);
            }
            catch (InvalidCastException)
            {
                return defaultValue;
            }
        }

        static public bool ConvertFromProjectProperty(String propertyValue, bool defaultValue)
        {
            if (String.IsNullOrEmpty(propertyValue))
                return defaultValue;

            try
            {
                return bool.Parse(propertyValue);
            }
            catch (InvalidCastException)
            {
                return defaultValue;
            }
        }
    }
}
